<template>
    <div>
        <div v-if="$v.resultError.required" class="uk-alert-danger" uk-alert>
            <a v-on:click="resultError=''" class="uk-alert-close" uk-close></a>
            <p>{{resultError}}</p>
        </div>
        <div class="uk-card uk-card-default uk-card-body">
            <h3 class="uk-card-title">Default</h3>
            <div class="uk-margin">
                <div class="uk-flex">
                    <div class="uk-width-1-2">
                        <div>

                            <label>
                                <input
                                        v-autowidth="{maxWidth: '40%', minWidth: '20px', comfortZone: 10}"
                                        class="cw-input katex resizable cw-input katex-small" style="text-align: center"
                                        v-model="end" type="text">
                            </label>
                        </div>
                        <label>
        <span style="font-size: 24pt" v-katex="'\\int'">
        </span>
                            <input
                                    v-autowidth="{maxWidth: '40%', minWidth: '20px', comfortZone: 10}"
                                    class="cw-input katex resizable cw-input katex-small" style="text-align: center"
                                    v-model="funct" type="text"/>
                        </label>
                        <span style="font-size: 16pt" class="katex">
                                dx
                        </span>
                        <div>
                            <label>
                                <input
                                        v-autowidth="{maxWidth: '40%', minWidth: '20px', comfortZone: 10}"
                                        class="cw-input katex resizable cw-input katex-small" style="text-align: center"
                                        v-model="begin" type="text">
                            </label>
                        </div>
                    </div>
                    <div v-if="!$v.requiredGroup.$invalid"  class="uk-width-1-2">
                        <span style="font-size: 16pt" v-katex="'\\int'+parseLatexSegment()+parseLatex()"></span>
                        <span style="font-size: 16pt" v-if="$v.result.result.required" v-katex="'=' + result.result + '+ R(x)'" ></span>
                        <br/>
                        <span style="font-size: 16pt" v-if="$v.result.error.required" v-katex="'R(x) = ' + result.error" ></span>
                    </div>
                </div>
                <div v-if="$v.requiredGroup.$invalid">
                    <div class="error" v-if="!$v.begin.maxLength||!$v.end.maxLength">{{ errorLen($v.x0) }}</div>
                    <div class="error" v-if="!$v.funct.maxLength">{{ errorLen($v.funct) }}</div>
                    <div class="error" v-if="!$v.requiredGroup.required">Fields is required</div>
                    <div class="error" v-if="!$v.begin.mathExpr||!$v.end.mathExpr">The field must
                        contain only numbers.
                    </div>
                </div>
                <label class="uk-form-label">
                    <span v-katex="'\\varepsilon='+getError()"></span>
                    <input id="rng" v-model="hop" class="uk-range" type="range" min="0"
                           max="10" :step="1"/>
                </label>
                <hr>
                <button :disabled="$v.requiredGroup.$invalid||resultLoader" v-on:click="solve"
                        class="uk-button uk-button-default uk-float-right">
                    <span v-if="resultLoader" uk-spinner="ratio: 1"></span>
                    <span v-if="!resultLoader">Solve</span>
                </button>
            </div>
        </div>
    </div>
</template>

<script>
    import AsciiMathParser from 'asciimath2tex';
    import {required, maxLength} from 'vuelidate/lib/validators'
    import axios from 'axios';

    const RECAPTCHA_TOKEN = `6LfH7pcUAAAAAFQRu7gxejZzC57TYZY0qOwcDJmJ`;
    const parser = new AsciiMathParser();
    const mathExpr = (value) => {
        return !(/[^pie./*\-+\d]/i.test(value))
    };
    export const HTTP = axios.create({
        baseURL: (process.env.NODE_ENV === 'development') ? 'http://localhost:8081/api' : 'https://cw.enderbot.ru/api',
        timeout: 120000,
        withCredentials: false,
        headers: {
            'Content-Type': 'application/json'
        }
    });
    export default {
        name: "CourseWork",
        data: function () {
            return {
                funct: '',
                begin: '',
                end: '',
                resultError: '',
                error: 1,
                hop: 0,
                resultLoader: false,
                result: {
                    result: '',
                    error: ''
                }
            }
        },
        methods: {
            parseLatex: function () {
                if (this.funct === '') {
                    return ' ';
                }
                return parser.parse(this.funct.toString()).toString();
            },
            parseLatexSegment: function () {
                //_{'+end+'}^{'+begin+'}'
                return '_{' + parser.parse(this.begin) + '}^{' + parser.parse(this.end) + '}';
            },
            getError: function () {
                return this.error = 1 / Math.pow(10, this.hop);
            },
            onTaskCompleted: function (data) {
                HTTP.get('/courseWork', {
                    params: {
                        id: data
                    }
                }).then((response) => {
                    this.result = response.data;
                    console.log(response.data)
                }).catch((error) => {
                    if (error.response) {
                        console.error(error.response.data);
                        console.error(error.response.status);
                        console.error(error.response.headers);
                        this.resultError = error.data;
                    } else if (error.request) {
                        this.resultError = error.message;
                        console.error(error.code);
                        console.error(error.request);
                    } else {
                        this.resultError = error.message;
                        console.error('Error', error.message);
                    }
                });
            },
            createTask: function (data) {
                const self = this;
                let axiosPromise = HTTP.post('/courseWork', data);
                axiosPromise.then((response) => {
                    console.log(response.data);
                    let url = 'https:///cw.enderbot.ru/api/notify/' + response.data;
                    // noinspection ES6ModulesDependencies
                    if (process.env.NODE_ENV === 'development') url = "http://localhost:8081/api/notify/" + response.data;
                    const eventSource = new EventSource(url);
                    eventSource.onmessage = function (e) {
                        console.log("Пришло уведомление: " + e.data);
                        if (e.data === 'success'||e.data === 'completed') {
                            self.onTaskCompleted(response.data);
                            eventSource.close();
                            // noinspection JSPotentiallyInvalidUsageOfThis
                            self.resultLoader = false;
                        }
                    };
                    eventSource.onerror = function (error) {
                        self.resultError = error.data;
                        // noinspection JSPotentiallyInvalidUsageOfThis
                        self.resultLoader = false;
                        eventSource.close();
                    };
                }).catch((error) => {
                    if (error.response) {
                        console.error(error.response.data);
                        console.error(error.response.status);
                        console.error(error.response.headers);
                        this.resultError = error.data;
                    } else if (error.request) {
                        this.resultError = error.message;
                        console.error(error.code);
                        console.error(error.request);
                    } else {
                        this.resultError = error.message;
                        console.error('Error', error.message);
                    }
                }).then(() => {
                    this.resultLoader = false;
                });
            },
            solve: async function () {
                this.resultLoader = true;
                // const token = "tejghahjg@124asd";
                const token = await this.recaptchaToken();
                let data = {
                    'token': token,
                    'data': {
                        'function': this.funct,
                        'begin': this.begin,
                        'end': this.end,
                        'error': this.error,
                    }
                };
                console.log('token: ' + token);
                console.log('data: ' + JSON.stringify(data));
                this.createTask(data)

            },
            recaptchaToken: async function () {
                return new Promise((resolve) => {
                    // noinspection JSUnresolvedVariable
                    // eslint-disable-next-line no-undef
                    grecaptcha.ready(async () => {
                        // noinspection ES6ModulesDependencies
                        // noinspection JSUnresolvedVariable
                        // eslint-disable-next-line no-undef
                        const token = await grecaptcha.execute(RECAPTCHA_TOKEN);
                        resolve(token);
                    });
                });
            },
        },
        validations: {
            resultError: {
                required
            },
            begin: {
                mathExpr,
                required,
                maxLength: maxLength(27),
            },
            end: {
                mathExpr,
                required,
                maxLength: maxLength(27),
            },
            funct: {
                required,
                maxLength: maxLength(64),
            },
            result: {
                result:{
                    required,
                },
                error:{
                    required,
                }
            },
            requiredGroup: ['begin', 'end', 'funct'],
            digitsGroup: ['begin', 'end'],
        },
        watch: {
            funct: function (data) {
                this.result ={
                    result: '',
                    error: ''
                };
            },
            begin: function (data) {
                this.result ={
                    result: '',
                    error: ''
                };
            },
            end: function (data) {
                this.result ={
                    result: '',
                    error: ''
                };
            },
        }

    }
</script>

<style scoped>

</style>
